// See my super games on http://lajili.com
define(["Game/Map", "Game/Player", "Game/config"], function(map, Player, config)
{
	var moteur;
	var player = new Player;
	window.player = player;
	// The main file of your game, the engine will call its functions init and update. The init will have the engine as a parameter
	function init (LajiliEngine) 
	{
		moteur = LajiliEngine; // I get the engine (the var is at the beginning of the file)
		moteur.world.init({x:0,y:8}); // I init the world
		//I create a few objects i'll use lateron
		moteur.world.createPhysicalObjectType({id: "blackBox", shape: "square", image: "blackBox", width: 0.25, height: 0.25, density: 0.5, friction: 1, restitution: 0})
		moteur.world.createPhysicalObjectType({id: "whiteBox", shape: "square", image: "whiteBox", width: 0.25, height: 0.25, density: 0.5, friction: 1, restitution: 0})
		moteur.world.createPhysicalObjectType({id: "player", shape: "square", image: "handshroomWhite", width: 0.25, height: 0.16, density: 0.5, friction: 0, restitution: 0.2, imageWidth: 0.4, imageHeight: 0.2, imageOffset: {x:0, y: 0.05}, fixedRotation: true, animated: true})
		moteur.world.createPhysicalObjectType({id: "coupDePoing", shape: "round", width: 0.24, height: 0.24, trigger: "true", density: 0, friction: 0})
		moteur.world.createPhysicalObjectType({id: "whitePlateforme", shape: "square", image: "whitePlateforme", width: moteur.utils.metters(80), height: moteur.utils.metters(37), density: 0.5, friction: 1, restitution: 0, imageOffset: {x:0, y:moteur.utils.metters(20)},animated: true})
		moteur.world.createPhysicalObjectType({id: "blackPlateforme", shape: "square", image: "blackPlateforme", width: moteur.utils.metters(80), height: moteur.utils.metters(37), density: 0.5, friction: 1, restitution: 0, imageOffset: {x:0, y:moteur.utils.metters(20)}, animated: true})
		var offset = moteur.utils.metters(config.width/5);
		// I parse the map (see map.js) to instance every object
		for (var i=0; i<map.length; i++)
		{
			for (var e=0; e<map[i].length; e++)
			{
				if (map[i][e] == 1 )
					{
						moteur.world.instancePhysicalObject("blackBox", true, e/2+offset, i/2+0.30, null, []);
					}
				if (map[i][e] == 2 ) 
					{
						moteur.world.instancePhysicalObject("whiteBox", false, e/2+offset, i/2+0.30, null, ["punchable"]);
					}
				if (map[i][e] == 3 ) 
					{
						// I instance the player
						player.physical = moteur.world.instancePhysicalObject("player", false, e/2+offset, i/2+0.30, {onCollision: function(){
						player.jumpAllowed = true;
						}}, ["punchable"]);
					}
				if (map[i][e] == 4 )
					{
						moteur.world.instancePhysicalObject("whitePlateforme", true, e/2+offset, i/2+0.30, null, []);
					}	 
				if (map[i][e] == 5 )
					{
						moteur.world.instancePhysicalObject("blackPlateforme", true, e/2+offset, i/2+0.30, null, []);
					}	 
			}
		}
		window.moteur =(moteur) // If you want to debug easyly.
	}

	function update()
	{
		player.load = player.leftLoad || player.rightLoad;
		if (player.timerCoup > 0) {player.timerCoup--} // A variable that prevent invoking 50000 'coupDePoing' each second.
		if (moteur.gamepads.length >= 1) // If a gamepad is connected
		{

			for (var padIndex = 0; padIndex <moteur.gamepads.length; padIndex++) //For each controller
			{
				player.physical.body.SetLinearVelocity({x:moteur.gamepads[padIndex].axes[0]*3, y: player.physical.body.GetLinearVelocity().y})// I gave the player the velocity of the controller (only one player for now)
				if (moteur.gamepads[padIndex].axes[0] >= 0.2 && player.load == false && player.attack == false)
				{
					player.physical.renderer.state = "move";
					player.physical.renderer.dir = "right";
				//	console.log("right")
				}else
				if (moteur.gamepads[padIndex].axes[0] <= -0.2 && player.load == false && player.attack == false)
				{
					player.physical.renderer.state = "move";
					player.physical.renderer.dir = "left";
				//	console.log("left")
				}else
				if (moteur.gamepads[padIndex].axes[0] > -0.2 && moteur.gamepads[padIndex].axes[0] < 0.2 && player.load == false && player.attack == false)
				{
					player.physical.renderer.state = "idle";
					player.physical.renderer.dir = "right";
				//	console.log("idle")
				}
				if (moteur.gamepads[padIndex].buttons[0] >= 0.4) // If the button 0 is pressed
				{
				//	console.log("saut")
					if (player.jumpAllowed) // If the player can jump
					{
						player.physical.body.SetLinearVelocity({x: player.physical.body.GetLinearVelocity().x, y: -4}) // I set its linear Velocity
						player.jumpAllowed = false; // I say he cannot jump any more
					}
				}
				if (moteur.gamepads[padIndex].buttons[1] >= 0.4) // If the player press the punch button
				{
					player.physical.renderer.state = "load";
					player.physical.renderer.dir = "right";
					player.rightLoad = true;
					/*player.timerCoup = player.timerMaxCoup; // I set the timer at the max
					console.log("poing droit");
					// I instance a coup with a 'onCollision' function. if the objectTouche is punchable, i give a linear velocity to the objetTouche
					var coup = moteur.world.instancePhysicalObject("coupDePoing", false, player.physical.body.GetPosition().x+1,player.physical.body.GetPosition().y, {onCollision:function(body){
					
						var objetTouche = moteur.world.getObject(body.m_userData.id);
						
						if (objetTouche.tags[0] == "punchable")
						{
							objetTouche.body.SetLinearVelocity({x: 5, y: objetTouche.body.GetLinearVelocity().y})
						}
					console.log(coup)

					}}, ["coup"])
					moteur.world.removeObject(coup)
					*/
				}
				if (moteur.gamepads[padIndex].buttons[2] >= 0.4)
				{
					player.physical.renderer.state = "load";
					player.physical.renderer.dir = "left"
					player.leftLoad = true;
				}

				if (player.rightLoad == true && moteur.gamepads[padIndex].buttons[1] < 0.4)
				{
					player.rightLoad = false;
					player.physical.renderer.state = "attack";
					player.physical.renderer.dir = "right";
					player.attack = true;
					player.physical.renderer.step = 0;
				}
				
				if (player.leftLoad == true && moteur.gamepads[padIndex].buttons[2] < 0.4)
				{
					player.leftLoad = false;
					player.physical.renderer.state = "attack";
					player.physical.renderer.dir = "left";
					player.physical.renderer.step = 0;
					player.physical.renderer.onEnd = function(){
						player.setNormal();
					}
					player.attack = true;
					//player.physical.renderer.step = 0;
				}

			}		
		}
	}
	return {init: init, update: update}
})